#ifndef PWM_CONFIG_H_
#define PWM_CONFIG_H_


typedef enum {
	MULTIA_0,
	MULTIA_1,
	MULTIA_2,
	MULTIA_3} multia_sel_t;
	// Type pour le choix du module pwm (carte multiA)
typedef enum {
	PAIR_A,
	PAIR_B,
	PAIR_C,
	PAIR_D	} pwm_pait_sel_t;
	// Type pour le choix de la paire PWM (sur une carte multiA donne)

// Definition of a type PWM_Pair containing the 3 parameters for a PWM paiR
typedef struct{
	Uint16 DTIME;
	Uint16 PHASE;
} PWM_Pair;

// Definition of a type PWM_Module which is a array of 4 PWM_Pair
typedef PWM_Pair PWM_Module[4];

// Init all the parameters with default values
void InitAllPWM();

// Set the Dead-time of a given pair
void setPWMDeadTime(int module, char pair, Uint16 Dtime);

// Set the phase angle of a given pair
void setPWMPhase(int module, char pair, Uint16 phase);

// Compute the falling and rising edges of a given pair
void setPWMDutyCycle(int module, char pair, float D);

// Set the Prescaler of a PWM module
void setPWMPrescaler(int module, Uint16 prescaler);

// set the Period of a PWM module
void setPWMPeriod(int module, Uint16 period);

// Sets all pwm signals of a module as inactive
void resetPWMDutyCycle(int module);

// Sets both signals of a pwm pair as inactive
void resetPWMDutyCyclePair(int module, char pair);


#endif /* PWM_CONFIG_H_ */
