#ifndef USER_CONFIG_H_
#define USER_CONFIG_H_

/*
 * Pre-computed general constants
 */
#define PI 3.141592654
#define SQRT2 1.414213
#define ONEOVERSQRT2 0.70710706237
/*
 * Time-related definitions
 */
#define SAMPLING_PERIOD 250e-6
#define SAMPLING_PERIOD_US 250

/*
 * Daughterboard definitions
 */
#define MULTIA_SLOT 0

/*
 * ADC-related definitions
 */
#define LEM_VOLTAGE_CHANNEL 0
#define LEM_VOLTAGE_GAIN 0.0561
#define LEM_VOLTAGE_OFFSET 0.0561
#define LEM_CURRENT_CHANNEL 1
#define LEM_CURRENT_GAIN 0.0032
#define LEM_CURRENT_OFFSET -0.0064

/*
 * PWM-related definitions
 */
#define PWM_PRESCALER 0					//prescaler = 2 and period = 7499 gives a PWM clock of 2kHz
#define PWM_PERIOD 6499					//prescaler = 0 and period = 6499 gives a PWM clock of 6.9kHz
#define PWM_DEADTIME 54					//prescaler = 2, deadtime = 18. prescaler = 0, deadtime = 54.
#define PWM_PHASE 0						//same as default value, so setup is not updated after general PWM initialization
#define PWM_MAX 0.97					//Duty cycle above this value the PWM value is set to 1
#define PWM_MIN 0.03					//Duty cycle below this value the PWM value is set to 0

/*
 *	ACChopper-related definitions
 */
#define CURRENT_THRESHOLD 0.02
#define VOLTAGE_RISING_THRESHOLD 1		//6,9k: 1		2.0k: 3
#define VOLTAGE_FALLING_THRESHOLD 7		//6,9k: 7		2.0k: 15

/*
 * 	DEBUG-related definitions
 */
#define DEBUG_BUFFER_SIZE 100

/*
 * REGULATOR-related definitions
 */
#define REG_A1 16.2670
#define REG_A2 -33.4137
#define REG_A3 15.4902
#define REG_A4 4.6476
#define REG_A5 -2.9159
#define REG_UPPER 1.0
#define REG_LOWER 0.0
/*
 * Other modules-related definitions
 */
#define SOGI_OMEGA 314.1592654			// 50Hz signal
#define SOGI_GAIN 1.0					// found by simulation
//#define SOGI_CONST 0.0000416667			// Sampling period divided by 12, here Ts = 1/2000
#define SOGI_CONST 0.000012037			// Sampling period divided by 12, here Ts = 1/6923

//#define T_SAMPLE 0.0005
#define T_SAMPLE 0.0001444

#define PLL_A 0.1
#define PLL_K 0.6


#endif /* USER_CONFIG_H_ */
