#ifndef GPO_H_
#define GPO_H_

#include "mapping.h"				// Definition of the available DSP peripherals

#define GPO_bitmask 0x0011

/**
 * Routine to initialize the FPGA register to zero
 * @param void
 * @return void
 */
void InitAllGPO();

/**
 * Routine to set a given bit to ONE
 * @param bit	the bit that should be set to ONE (7 downto 0)
 * @return void
 */
void setGPObit(int bit);

/**
 * Routine to clear a given bit to ZERO
 * @param bit	the bit that should be set to ZERO (7 downto 0)
 * @return void
 */
void clearGPObit(int bit);

/**
 * Routine to set a toggle a given bit value
 * @param bit	the bit that should be toggeled (7 downto 0)
 * @return void
 */
void toggleGPObit(int bit);

/**
 * Routine to force a given bit to the the value given as parameter
 * @param bit	the bit that should be toggeled (7 downto 0)
 * @param value the new value to be loaded in the FPGA register
 * @return void
 */
void forceGPObit(int bit, int value);

/**
 * Routine to set the whole FPGA register to a given value
 * @param value  the new value that should be send to the FPGA register (8 bits only)
 * @return void
 */
void setGPO(int value);

#endif /* GPO_H_ */
