#ifndef HARDWARE_H_
#define HARDWARE_H_

/*
 * This file defines the input/output pinout on the TMS320C28346 Delfino DSP
 * These definitions are specific to the BoomBox or the MMC-Box
 */


/*
 * LED output pins definitions
 * These definitions applies for the onboard LEDs
 */
//#define SIG_nFAULT		(GpioDataRegs.GPADAT.bit.GPIO0) 	// PWM_nFAULT is input
#define SIG_nHPR			(GpioDataRegs.GPADAT.bit.GPIO1)		// nHPR is used to block the multiA frontpanels

#define SYS_LED_IDLE()		GpioDataRegs.GPASET.all = 1 << 3; \
							GpioDataRegs.GPACLEAR.all = 1 << 2;
#define SYS_LED_NORMAL()	GpioDataRegs.GPASET.all = 3 << 2;
#define SYS_LED_ERROR()		GpioDataRegs.GPASET.all = 1 << 2; \
							GpioDataRegs.GPACLEAR.all = 1 << 3;

#define USER_LED0_RED()		GpioDataRegs.GPASET.all = 1 << 4; \
							GpioDataRegs.GPACLEAR.all = 1 << 5;
#define USER_LED0_GREEN()	GpioDataRegs.GPASET.all = 1 << 5; \
							GpioDataRegs.GPACLEAR.all = 1 << 4;
#define USER_LED0_ORANGE()	GpioDataRegs.GPASET.all = 3 << 4;
#define USER_LED0_OFF()		GpioDataRegs.GPACLEAR.all = 3 << 4;

#define USER_LED1_RED()		GpioDataRegs.GPASET.all = 1 << 6; \
							GpioDataRegs.GPACLEAR.all = 1 << 7;
#define USER_LED1_GREEN()	GpioDataRegs.GPASET.all = 1 << 7; \
							GpioDataRegs.GPACLEAR.all = 1 << 6;
#define USER_LED1_ORANGE()	GpioDataRegs.GPASET.all = 3 << 6;
#define USER_LED1_OFF()		GpioDataRegs.GPACLEAR.all = 3 << 6;

#define USER_LED2_RED()		GpioDataRegs.GPASET.all = 1 << 8; \
							GpioDataRegs.GPACLEAR.all = 1 << 9;
#define USER_LED2_GREEN()	GpioDataRegs.GPASET.all = 1 << 9; \
							GpioDataRegs.GPACLEAR.all = 1 << 8;
#define USER_LED2_ORANGE()	GpioDataRegs.GPASET.all = 3 << 8;
#define USER_LED2_OFF()		GpioDataRegs.GPACLEAR.all = 3 << 8;

#define USER_LED3_RED()		GpioDataRegs.GPASET.all = 1 << 11; \
							GpioDataRegs.GPACLEAR.all = 1 << 12;
#define USER_LED3_GREEN()	GpioDataRegs.GPASET.all = 1 << 12; \
							GpioDataRegs.GPACLEAR.all = 1 << 11;
#define USER_LED3_ORANGE()	GpioDataRegs.GPASET.all = 3 << 11;
#define USER_LED3_OFF()		GpioDataRegs.GPACLEAR.all = 3 << 11;


#define SPI_DELFINO_BLOCK_OUTPUTS   0xAFAF
#define SPI_DELFINO_RELEASE_OUTPUTS 0xA0A0
#define SPI_DELFINO_WHO_IS_THERE    0xAAAA

/**
 * Input pins definitions
 * These definitions applies for the interrupt sources
 */
#define XINT1_SOURCE 23		// Refers to GPIO23
#define XINT2_SOURCE 22		// Refers to GPIO22
#define XNMI_SOURCE 0		// Refers to GPIO0


#endif /*HARDWARE_H_*/
