% clear all;
% close all;

%% Parameters

%simulation parameter
sim_time = 0.2*2;
sim_maxstep = 5e-5;

%grid parameters:
Uline = 1 * sqrt(2);				%grid line voltage
fnet = 50;							%grid frequency
wnet = 2* pi * fnet;				%grid angle speed

%per unit parameters:
Unom = 50;
Inom = 2.4;
Znom = Unom / Inom;

%ciruit parameters:
Ra = 0.5;							%load resistance
La = 5e-3;							%load inductance
Ca = 140e-6;						%load capacitance


ra = Ra / Znom;													%load resistance in p.u.
ca = Znom / (wnet*La - 1/(wnet*Ca)) * (wnet*La*Ca - 1 / wnet);	%load capacitance in p.u.
la = La*Ca/ca;													%load inductance in p.u.

%The system in s-plane
% Gs = tf([1 0],[la ra 1/ca]);

%SOGI parameters
% SOGI_var

%PWM parameters:
fsw = 2e3;							%switching frequency
Tp = 1/fsw;							%switching period
porteur_values = [0.01 1 0.01];
% porteur_values = [-1 1 -1];

threshold = 15;

bias = 0.5;

uh = 0.2;
fh = 6*fnet;
dephase = 0;

uh2 = uh;
fh2 = fh + 2*fnet;
dephase2 = dephase + 0;

uh3 = uh*0;
fh3 = fh2+ 2*fnet;
dephase3 = dephase + 0;

%% Simulation

sim('Chopper_discreteswitch_openloop')

%% Plotting

figure;
plot(t_plecs, u_source, t_plecs, i_source, [0 sim_time*1.05], [0 0], '--k')
title('Source');


figure;
plot(t_plecs, u_imp, t_plecs, i_imp, [0 sim_time*1.05], [0 0], '--k')
title('Impedance');

% 
% figure;
% plot(t_controller, u_con, t_plecs, u_source);
% title('Controller set voltage');


FFT_info(fft_mes1, 0, 0, 1e5);
FFT_info(fft_mes2, 0, 0, 1e5);

% figure; plot(t_plecs, sign(u_ca).*u_ca.^2*ca/2, t_plecs, sign(i_imp).*i_imp.^2*la/2)

% figure;
% plot(t, PWM)
% title('PWM function')