	
function res = FFT_info(var, flag_print, zero_padding, sample_frequency)
	
	%options
	plot_bandwidth = 1e3;
	
	
	%calculation
	n = length(var)/2;
	
	if (zero_padding)
		padlength = 10;
		Y = fft(var(n:2*n),n*padlength);
	else
		padlength = 1;
		Y = fft(var(n:2*n),n);
	end

	m = sample_frequency / plot_bandwidth;
	f = sample_frequency / (padlength*n)*(0:(padlength*n/m));
	
	% Pyy = Y.*conj(Y)/n;
	% figure; plot(f,Pyy(1:(n/2+1)))
	% title('Power spectral density')
	% xlabel('Frequency (Hz)')

	hFig = figure;
	set(gcf,'PaperPositionMode','auto')
	set(hFig, 'Position', [0 0 600 300])
 	plot(f,sqrt(2).*sqrt((abs(Y(1:padlength*n/m+1))/n).^2))
	%title([inputname(1) ', RMS'])
	xlabel('Frequency')
	ylabel('RMS value [p.u.]')
	

	%% Printing length and phase info for harmoincs of order h = 1:19
	
	if (flag_print)
		max_n_harmonic = 19;
		fft_angles = zeros(max_n_harmonic,1);
		fft_abs = zeros(max_n_harmonic,1);
		index = 1;

		for ii = 2:length(f)
			if (mod(f(ii),50) == 0)
				fft_angles(index) = angle(Y(ii));
				fft_abs(index) = sqrt(2).*sqrt((abs(Y(ii))/n).^2);
				index = index + 1;
			end
			if (index == (max_n_harmonic + 1))
				break;
			end
		end

		%Correct angles making the fundamental equal to the real axis
		for ii = 2:max_n_harmonic
			fft_angles(ii) = fft_angles(ii) - fft_angles(1);
		end
		fft_angles(1) = 0;

		%Print odd numbered harmonics
		for ii = 1:2:max_n_harmonic
			fprintf('h%i  abs & theta: \t%f \t%f\n', ii, fft_abs(ii),fft_angles(ii))
		end
		res = [fft_abs fft_angles];
	end
