	
function [fft_var, freq] = FFT_info_programmable(var, length, zero_padding, padding_gain, sample_frequency, y_title, win_height, win_width)
	
	%options
	plot_bandwidth = 1e3;
	
	
	%calculation
	n = length;
	
	if (zero_padding)
		Y = fft(var(1:n),n*padding_gain);
	else
		padding_gain = 1;
		Y = fft(var(1:n),n);
	end

	m = sample_frequency / plot_bandwidth;
	f = sample_frequency / (padding_gain*n)*(0:(padding_gain*n/m));
	
	% Pyy = Y.*conj(Y)/n;
	% figure; plot(f,Pyy(1:(n/2+1)))
	% title('Power spectral density')
	% xlabel('Frequency (Hz)')

	hFig = figure;
	set(gcf,'PaperPositionMode','auto');
	set(hFig, 'Position', [400 400 win_width win_height]);
 	plot(f,sqrt(2).*sqrt((abs(Y(1:padding_gain*n/m+1))/n).^2));
	
	xlabel('Frequency [Hz]');
	ylabel(y_title);
	
	fft_var = Y;
	freq = f;